package betterwithmods.client.container.bulk;

import betterwithmods.client.container.ContainerProgress;
import betterwithmods.common.BWRegistry;
import betterwithmods.common.registry.hopper.filters.HopperFilter;
import betterwithmods.common.tile.TileFilteredHopper;
import betterwithmods.util.CapabilityUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.SlotItemHandler;

import javax.annotation.Nonnull;

public class ContainerFilteredHopper extends ContainerProgress {
    private final TileFilteredHopper tile;

    public ContainerFilteredHopper(EntityPlayer player, TileFilteredHopper tile) {
        super(tile);
        this.tile = tile;

        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < 9; j++) {
                func_75146_a(new SlotItemHandler(tile.inventory, j + i * 9, 8 + j * 18, 60 + i * 18));
            }
        }

        func_75146_a(new SlotItemHandler(tile.filter, 0, 80, 37));

        IItemHandler playerInv = CapabilityUtils.getEntityInventory(player);

        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 9; j++) {
                func_75146_a(new SlotItemHandler(playerInv, j + i * 9 + 9, 8 + j * 18, 111 + i * 18));
            }
        }

        for (int i = 0; i < 9; i++) {
            func_75146_a(new SlotItemHandler(playerInv, i, 8 + i * 18, 169));
        }
    }

    @Nonnull
    @Override
    public ItemStack func_82846_b(EntityPlayer player, int index) {
        ItemStack clickedStack = ItemStack.field_190927_a;
        Slot slot = this.field_75151_b.get(index);

        if (slot != null && slot.func_75216_d()) {
            ItemStack processedStack = slot.func_75211_c();
            clickedStack = processedStack.func_77946_l();

            if (index < 19) {
                if (!func_75135_a(processedStack, 19, this.field_75151_b.size(), true))
                    return ItemStack.field_190927_a;
            } else if (BWRegistry.HOPPER_FILTERS.isFilter(processedStack)) {
                if (!func_75135_a(processedStack, 18, 19, false))
                    return ItemStack.field_190927_a;
            } else if (!func_75135_a(processedStack, 0, 18, false)) {
                return ItemStack.field_190927_a;
            }

            if (processedStack.func_190916_E() == 0)
                slot.func_75215_d(ItemStack.field_190927_a);
            else
                slot.func_75218_e();
        }
        return clickedStack;
    }

    private boolean isItemFilter(ItemStack stack) {
        return BWRegistry.HOPPER_FILTERS.getFilter(stack) != HopperFilter.NONE;
    }

    @Override
    public boolean func_75145_c(@Nonnull EntityPlayer playerIn) {
        return tile.isUseableByPlayer(playerIn);
    }

}
