package betterwithmods.client.tesr;

import betterwithmods.BWMod;
import betterwithmods.client.model.ModelWindmillSail;
import betterwithmods.client.model.ModelWindmillShafts;
import betterwithmods.client.model.render.RenderUtils;
import betterwithmods.common.tile.TileWindmillHorizontal;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;

public class TESRWindmill extends TileEntitySpecialRenderer<TileWindmillHorizontal> {
    public static final ResourceLocation WINDMILL = new ResourceLocation(BWMod.MODID, "textures/blocks/horizontal_windmill.png");
    public static final ResourceLocation WINDMILL_SAIL = new ResourceLocation(BWMod.MODID, "textures/blocks/horizontal_windmill_sail.png");

    private static final ModelWindmillShafts shafts = new ModelWindmillShafts();
    private static final ModelWindmillSail sail = new ModelWindmillSail();

    public static void renderWindmill(float direction, float rotation, double x, double y, double z, int[] colors) {
        GlStateManager.func_179094_E();
        GlStateManager.func_179137_b(x + 0.5D, y + 0.5D, z + 0.5D);

        shafts.setRotateAngle(shafts.axle, 0, 0, -(float) Math.toRadians(rotation));
        sail.setRotateAngleForSails(0, 0, -(float) Math.toRadians(rotation));
        GlStateManager.func_179114_b(direction, 0.0F, 1.0F, 0.0F);

        Minecraft.func_71410_x().func_110434_K().func_110577_a(WINDMILL);
        shafts.render(0.0625F);
        Minecraft.func_71410_x().func_110434_K().func_110577_a(WINDMILL_SAIL);
        sail.render(0.0625F, colors);
        GlStateManager.func_179121_F();
    }

    @Override
    public void func_192841_a(TileWindmillHorizontal te, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
        BlockPos pos = te.getBlockPos();
        RenderUtils.renderDebugBoundingBox(x, y, z, te.getRenderBoundingBox().func_72317_d(-pos.func_177958_n(), -pos.func_177956_o(), -pos.func_177952_p()));
        EnumFacing facing = te.getOrientation();
        float rotation = (te.getCurrentRotation() + (te.getMechanicalOutput(facing) == 0 ? 0 : partialTicks * te.getPrevRotation()));
        renderWindmill((facing == EnumFacing.SOUTH ? 180 : 90f), rotation, x, y, z, te.getColors());
    }


}
