package betterwithmods.common.blocks;

import betterwithmods.common.BWOreDictionary;
import net.minecraft.block.Block;
import net.minecraft.block.BlockSkull;
import net.minecraft.block.BlockTorch;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.BlockFaceShape;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import javax.annotation.Nonnull;

import betterwithmods.common.blocks.BlockStickBase.Connection;

public class BlockCandleHolder extends BlockStickBase {

    public BlockCandleHolder() {
        super(Material.field_151573_f);
        func_180632_j(func_176223_P().func_177226_a(CONNECTION, Connection.DISCONNECTED).func_177226_a(GROUND, true));
    }

    @Override
    public boolean func_176196_c(World worldIn, @Nonnull BlockPos pos) {
        return worldIn.isSideSolid(pos.func_177977_b(), EnumFacing.UP) || worldIn.func_180495_p(pos.func_177977_b()).func_177230_c() instanceof BlockCandleHolder;
    }

    @Override
    public void func_189540_a(IBlockState state, World worldIn, BlockPos pos, Block blockIn, BlockPos fromPos) {
        if (!func_176196_c(worldIn, pos)) {
            this.func_176226_b(worldIn, pos, state, 0);
            worldIn.func_175698_g(pos);
        }
        super.func_189540_a(state, worldIn, pos, blockIn, fromPos);
    }

    @Override
    public IBlockState getConnections(IBlockState state, IBlockAccess world, BlockPos pos) {
        IBlockState above = world.func_180495_p(pos.func_177984_a());
        Block block = above.func_177230_c();
        ItemStack stack = new ItemStack(block, 1, block.func_176201_c(above));
        BlockFaceShape shape = above.func_193401_d(world, pos.func_177984_a(), EnumFacing.DOWN);

        if (block == this) {
            return state.func_177226_a(CONNECTION, Connection.CONNECTED);
        } else if (shape == BlockFaceShape.SOLID || shape == BlockFaceShape.CENTER_SMALL || shape == BlockFaceShape.CENTER || isUprightTorch(above) || BWOreDictionary.isOre(stack, "blockCandle")) {
            return state.func_177226_a(CONNECTION, Connection.CANDLE);
        } else if (shape == BlockFaceShape.CENTER_BIG || block instanceof BlockSkull) {
            return state.func_177226_a(CONNECTION, Connection.SKULL);
        }
        return state;
    }

    public boolean isUprightTorch(IBlockState state) {
        return state.func_177230_c() instanceof BlockTorch && state.func_177229_b(BlockTorch.field_176596_a) == EnumFacing.UP;
    }

    @Override
    public double getHeight(IBlockState state) {
        Connection c = state.func_177229_b(CONNECTION);
        return c == Connection.DISCONNECTED ? 14d / 16d : 1;
    }

    @Nonnull
    @Override
    public BlockFaceShape func_193383_a(IBlockAccess world, IBlockState state, BlockPos pos, EnumFacing facing) {
        return facing == EnumFacing.DOWN ? BlockFaceShape.CENTER_SMALL : (facing == EnumFacing.UP ? BlockFaceShape.CENTER : BlockFaceShape.UNDEFINED);
    }
}
