package betterwithmods.common.blocks;

import betterwithmods.util.item.ToolsManager;
import net.minecraft.block.Block;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;
import java.util.Random;

public class BlockLight extends BWMBlock {
    public static final PropertyBool ACTIVE = PropertyBool.func_177716_a("active");

    public BlockLight() {
        super(Material.field_151592_s);
        this.func_149711_c(2.0F);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(ACTIVE, true));
        this.func_149672_a(SoundType.field_185853_f);
        ToolsManager.setPickaxesAsEffectiveAgainst(this);
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @Nonnull
    @Override
    @SideOnly(Side.CLIENT)
    public BlockRenderLayer func_180664_k() {
        return BlockRenderLayer.TRANSLUCENT;
    }

    @Override
    public int getLightValue(IBlockState state, IBlockAccess world, BlockPos pos) {
        if (state.func_177229_b(ACTIVE))
            return 15;
        return 0;
    }

    @Override
    public void func_176213_c(World world, BlockPos pos, IBlockState state) {
        if (!world.field_72995_K) {
            if (state.func_177229_b(ACTIVE) && !world.func_175640_z(pos) && !isIndirectlyPowered(world, pos))
                world.func_175656_a(pos, state.func_177226_a(ACTIVE, false));
            else if (!state.func_177229_b(ACTIVE) && (world.func_175640_z(pos) || isIndirectlyPowered(world, pos)))
                world.func_175656_a(pos, state.func_177226_a(ACTIVE, true));
        }
    }

    @SuppressWarnings("deprecation")
    @Override
    public void func_189540_a(IBlockState state, World world, BlockPos pos, Block block, BlockPos other) {
        if (!world.field_72995_K) {
            if (state.func_177229_b(ACTIVE) && !world.func_175640_z(pos) && !isIndirectlyPowered(world, pos))
                world.func_175684_a(pos, this, 4);
            else if (!state.func_177229_b(ACTIVE) && (world.func_175640_z(pos) || isIndirectlyPowered(world, pos))) {
                world.func_180501_a(pos, state.func_177226_a(ACTIVE, true), 2);
                for (EnumFacing facing : EnumFacing.field_82609_l) {
                    if (world.func_180495_p(pos.func_177972_a(facing)).func_177230_c() == this)
                        world.func_190524_a(pos.func_177972_a(facing), this, pos);
                }
            }
        }
    }

    private boolean isIndirectlyPowered(World world, BlockPos pos) {
        for (EnumFacing facing : EnumFacing.field_82609_l) {
            BlockPos check = pos.func_177972_a(facing);
            if (!world.func_175623_d(check) && !(world.func_180495_p(check).func_177230_c() instanceof BlockBUD) && world.func_175640_z(check))
                return true;
        }
        return false;
    }

    @Override
    public void func_180650_b(World world, BlockPos pos, IBlockState state, Random rand) {
        if (!world.field_72995_K) {
            if (state.func_177229_b(ACTIVE) && !world.func_175640_z(pos)) {
                world.func_180501_a(pos, state.func_177226_a(ACTIVE, false), 2);
                for (EnumFacing facing : EnumFacing.field_82609_l) {
                    if (world.func_180495_p(pos.func_177972_a(facing)).func_177230_c() == this)
                        world.func_190524_a(pos.func_177972_a(facing), this, pos);
                }
            }
        }
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(ACTIVE) ? 1 : 0;
    }

    @SuppressWarnings("deprecation")
    @Nonnull
    @Override
    public IBlockState func_176203_a(int meta) {
        return this.func_176223_P().func_177226_a(ACTIVE, meta == 1);
    }

    @Nonnull
    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, ACTIVE);
    }

    @SuppressWarnings("deprecation")
    @Override
    @SideOnly(Side.CLIENT)
    public boolean func_176225_a(IBlockState state, @Nonnull IBlockAccess world, @Nonnull BlockPos pos, EnumFacing side) {
        IBlockState neighbor = world.func_180495_p(pos.func_177972_a(side));
        return state != neighbor;
    }
}
