package betterwithmods.common.entity.ai.eat;

import betterwithmods.module.hardcore.creatures.chicken.EggLayer;
import betterwithmods.module.hardcore.creatures.chicken.HCChickens;
import net.minecraft.entity.passive.EntityAnimal;
import net.minecraft.entity.passive.EntityTameable;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.Ingredient;

public class EntityAIAnimalEat extends EntityAIEatFood<EntityAnimal> {

    public EntityAIAnimalEat(EntityAnimal entity, Ingredient validItem, double distance) {
        super(entity, validItem, distance);
    }

    @Override
    public boolean isReady() {
        return canBreed(entity);
    }

    @Override
    public void onEaten(ItemStack food) {
        EggLayer layer = HCChickens.getLayer(entity);
        if (layer != null) {
            layer.feed(entity, food);
        } else {
            entity.func_146082_f(null);
            food.func_190918_g(1);
        }
    }

    private boolean canBreed(EntityAnimal entity) {
        //Handle HCChickens
        EggLayer layer = HCChickens.getLayer(entity);
        if (layer != null) {
            return !layer.isFeed();
        }

        //Handle tamed animals
        if (entity instanceof EntityTameable) {
            return ((EntityTameable) entity).func_70909_n() && !((EntityTameable) entity).func_70906_o();
        }

        //Only adults that are read to breed
        if (!entity.func_70631_g_()) {
            return !entity.func_70880_s();
        }
        return false;
    }
}
