package betterwithmods.common.registry.block.recipe;

import betterwithmods.api.tile.IHeatRecipe;
import betterwithmods.common.registry.KilnStructureManager;
import betterwithmods.event.FakePlayerHandler;
import betterwithmods.util.InvUtils;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import java.util.List;
import java.util.Random;

/**
 * Created by primetoxinz on 5/16/17.
 */
public class KilnRecipe extends BlockRecipe implements IHeatRecipe {
    private final int heat;
    private boolean ignoreHeat;
    private int cookTime;

    public KilnRecipe(BlockIngredient input, List<ItemStack> outputs, int heat, int cookTime) {
        super(input, outputs);
        this.heat = heat;
        this.cookTime = cookTime;
    }

    @Override
    public int getHeat() {
        return heat;
    }

    public int getCookTime() {
        return cookTime;
    }

    public void setCookTime(int cookTime) {
        this.cookTime = cookTime;
    }

    @Override
    public boolean ignore() {
        return ignoreHeat;
    }

    public KilnRecipe setIgnoreHeat(boolean ignoreHeat) {
        this.ignoreHeat = ignoreHeat;
        return this;
    }

    @Override
    public boolean craftRecipe(World world, BlockPos pos, Random rand, IBlockState state) {
        InvUtils.ejectStackWithOffset(world, pos, onCraft(world, pos));
        state.func_177230_c().func_176208_a(world, pos, state, FakePlayerHandler.getSword());
        world.func_180501_a(pos, Blocks.field_150350_a.func_176223_P(), world.field_72995_K ? 11 : 3);
        return true;
    }

    @Override
    public boolean matches(World world, BlockPos pos, IBlockState state) {
        if (super.matches(world, pos, state)) {
            if (!ignore()) {
                int heat = KilnStructureManager.getKiln().getHeat(world, pos.func_177977_b());
                return heat == getHeat();
            }
            return true;
        }
        return false;
    }
}
