package betterwithmods.common.tile;

import betterwithmods.common.blocks.camo.BlockCamo;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class TileCamo extends TileBasic {

    public IBlockState state;


    public TileCamo() {
    }

    public static ItemStack fromParentState(Block mini, IBlockState state, int count) {
        ItemStack stack = new ItemStack(mini, count);
        NBTTagCompound tag = new NBTTagCompound();
        NBTTagCompound texture = new NBTTagCompound();
        NBTUtil.func_190009_a(texture, state);
        tag.func_74782_a("texture", texture);
        stack.func_77982_d(tag);
        return stack;
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, @Nonnull IBlockState oldState, @Nonnull IBlockState newState) {
        return oldState.func_177230_c() != newState.func_177230_c();
    }

    @Nonnull
    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {
        NBTTagCompound tag = super.func_189515_b(compound);
        if (state != null) {
            NBTTagCompound texture = new NBTTagCompound();
            NBTUtil.func_190009_a(texture, state);
            tag.func_74782_a("texture", texture);
        }
        return tag;
    }

    @Override
    public void func_145839_a(NBTTagCompound compound) {
        if (compound.func_74764_b("texture")) {
            try {
                state = NBTUtil.func_190008_d(compound.func_74775_l("texture"));
            } catch (Throwable e) {
                e.printStackTrace();
            }
        }
        super.func_145839_a(compound);
    }

    @Override
    public void onPlacedBy(EntityLivingBase placer, @Nullable EnumFacing face, ItemStack stack, float hitX, float hitY, float hitZ) {
        loadFromStack(stack);
    }

    public void loadFromStack(ItemStack stack) {
        NBTTagCompound tag = stack.func_179543_a("texture");
        if (tag != null) {
            state = NBTUtil.func_190008_d(tag);
        }
    }

    public void markBlockForRenderUpdate() {
        field_145850_b.func_175704_b(field_174879_c, field_174879_c);
    }

    public void markBlockForUpdate() {
        IBlockState state = field_145850_b.func_180495_p(field_174879_c);
        field_145850_b.func_184138_a(field_174879_c, state, state, 3);
    }

    public IBlockState getState() {
        if (state == null)
            return Blocks.field_150350_a.func_176223_P();
        return state;
    }

    public void setState(IBlockState state) {
        this.state = state;
    }

    public ItemStack getPickBlock(EntityPlayer player, RayTraceResult target, IBlockState state) {
        if (this.state != null && state.func_177230_c() instanceof BlockCamo) {
            return fromParentState(state.func_177230_c(), this.state, 1);
        }
        return ItemStack.field_190927_a;
    }


}
