package betterwithmods.module.tweaks;

import betterwithmods.BWMod;
import betterwithmods.common.world.BWMapGenMineshaft;
import betterwithmods.common.world.BWStructureMineshaftPieces;
import betterwithmods.module.Feature;
import net.minecraft.block.BlockNewLog;
import net.minecraft.block.BlockPlanks;
import net.minecraft.block.BlockRail;
import net.minecraft.block.BlockRailBase;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.ResourceLocation;
import net.minecraft.world.gen.structure.MapGenMineshaft;
import net.minecraft.world.gen.structure.MapGenStructureIO;
import net.minecraft.world.gen.structure.StructureMineshaftPieces;
import net.minecraftforge.event.terraingen.InitMapGenEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class MineshaftGeneration extends Feature {
    public static IMineshaftBlockState roomFloor;
    public static IMineshaftBlockState rail;
    public static IMineshaftBlockState planks;
    public static IMineshaftBlockState supports;

    @Override
    public String getFeatureDescription() {
        return "Mineshafts now generate with logs instead of fences";
    }

    @Override
    public boolean requiresMinecraftRestartToEnable() {
        return true;
    }

    @Override
    public boolean hasTerrainSubscriptions() {
        return true;
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }

    @Override
    public void init(FMLInitializationEvent event) {
        MapGenStructureIO.func_143034_b(BWMapGenMineshaft.BWStructureMineshaftStart.class, new ResourceLocation(BWMod.MODID, "BWMineshaftStart").toString());
        MapGenStructureIO.func_143031_a(BWStructureMineshaftPieces.Corridor.class, new ResourceLocation(BWMod.MODID, "BWMSCorridor").toString());
        MapGenStructureIO.func_143031_a(BWStructureMineshaftPieces.Cross.class, new ResourceLocation(BWMod.MODID, "BWMSCrossing").toString());
        MapGenStructureIO.func_143031_a(BWStructureMineshaftPieces.Room.class, new ResourceLocation(BWMod.MODID, "BWMSRoom").toString());
        MapGenStructureIO.func_143031_a(BWStructureMineshaftPieces.Stairs.class, new ResourceLocation(BWMod.MODID, "BWMSStairs").toString());

        roomFloor = piece -> Blocks.field_150346_d.func_176223_P();
        rail = piece -> Blocks.field_150448_aq.func_176223_P().func_177226_a(BlockRail.field_176565_b, BlockRailBase.EnumRailDirection.NORTH_SOUTH);
        planks = piece -> getPlankForType(piece.field_189920_a);
        supports = piece -> getSupportForType(piece.field_189920_a);
    }

    @SubscribeEvent
    public void onGenerate(InitMapGenEvent event) {
        if (event.getType() == InitMapGenEvent.EventType.MINESHAFT) {
            event.setNewGen(new BWMapGenMineshaft());
        }
    }

    public IBlockState getPlankForType(MapGenMineshaft.Type mineShaftType) {
        switch (mineShaftType) {
            case NORMAL:
            default:
                return Blocks.field_150344_f.func_176223_P();
            case MESA:
                return Blocks.field_150344_f.func_176223_P().func_177226_a(BlockPlanks.field_176383_a, BlockPlanks.EnumType.DARK_OAK);
        }
    }

    public IBlockState getSupportForType(MapGenMineshaft.Type mineShaftType) {
        switch (mineShaftType) {
            case NORMAL:
            default:
                return Blocks.field_150364_r.func_176223_P();
            case MESA:
                return Blocks.field_150363_s.func_176223_P().func_177226_a(BlockNewLog.field_176300_b, BlockPlanks.EnumType.DARK_OAK);
        }
    }

    public interface IMineshaftBlockState {
        IBlockState getBlockState(StructureMineshaftPieces.Peice piece); //For evil plans
    }
}
