package betterwithmods.network;

import betterwithmods.BWMod;
import betterwithmods.network.handler.*;
import betterwithmods.network.messages.*;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.network.Packet;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.SimpleNetworkWrapper;
import net.minecraftforge.fml.relauncher.Side;

public class BWNetwork {

    public static final SimpleNetworkWrapper INSTANCE = NetworkRegistry.INSTANCE.newSimpleChannel(BWMod.MODID);
    private static int i = 0;

    public static void registerNetworking() {
        registerMessage(MessageHungerShakeHandler.class, MessageHungerShake.class, Side.CLIENT);
        registerMessage(MessageHarnessHandler.class, MessageHarness.class, Side.CLIENT);
        registerMessage(MessageRotateHandler.class, MessageRotate.class, Side.CLIENT);
        registerMessage(MessageGloomHandler.class, MessageGloom.class, Side.CLIENT);
        registerMessage(MessagePlacedHandler.class, MessagePlaced.class, Side.CLIENT);
    }

    public static <REQ extends IMessage, REPLY extends IMessage> void registerMessage(Class<? extends IMessageHandler<REQ, REPLY>> messageHandler, Class<REQ> requestMessageType, Side side) {
        INSTANCE.registerMessage(messageHandler, requestMessageType, i++, side);
    }


    public static void sendPacket(Entity player, Packet<?> packet) {
        if (player instanceof EntityPlayerMP && ((EntityPlayerMP) player).field_71135_a != null) {
            ((EntityPlayerMP) player).field_71135_a.func_147359_a(packet);
        }
    }

    public static void sendTo(IMessage message, EntityPlayerMP player) {
        INSTANCE.sendTo(message, player);
    }

    public static void sendToAllAround(IMessage message, World world, BlockPos pos) {
        INSTANCE.sendToAllAround(message, new NetworkRegistry.TargetPoint(world.field_73011_w.getDimension(), pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p(), 128));
    }

}
