package betterwithmods.testing.base.world;

import com.google.common.collect.Maps;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.init.Blocks;
import net.minecraft.profiler.Profiler;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.chunk.IChunkProvider;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.Map;

public class FakeWorld extends World {

    private final Map<BlockPos, IBlockState> states = Maps.newHashMap();

    public FakeWorld() {
        super(new FakeSaveHandler(), new FakeWorldInfo(), new FakeWorldProvider(), new Profiler(), false);
    }

    @Nonnull
    @Override
    protected IChunkProvider func_72970_h() {
        return null;
    }

    @Override
    public boolean func_175656_a(@Nonnull BlockPos pos, @Nonnull IBlockState state) {
        this.states.put(pos, state);
        return true;
    }

    @Nonnull
    @Override
    public IBlockState func_180495_p(@Nonnull BlockPos pos) {
        return states.getOrDefault(pos, Blocks.field_150350_a.func_176223_P());
    }

    @Override
    protected boolean func_175680_a(int x, int z, boolean allowEmpty) {
        return false;
    }

    @Nullable
    @Override
    public Entity func_73045_a(int id) {
        return null;
    }

    @Override
    public boolean func_175698_g(@Nonnull BlockPos pos) {
        func_175656_a(pos, Blocks.field_150350_a.func_176223_P());
        return true;
    }

    @Override
    public boolean func_72838_d(@Nonnull Entity entityIn) {
        return true;
    }
}
